Index: branches/network/src/lib/network/Makefile.am
===================================================================
--- branches/network/src/lib/network/Makefile.am	(revision 6115)
+++ branches/network/src/lib/network/Makefile.am	(revision 6116)
@@ -13,5 +13,5 @@
 		      server_socket.cc \
 		      handshake.cc \
-		      entity_manager.cc \
+		      network_game_manager.cc \
 		      converter.cc
 
@@ -28,5 +28,5 @@
 		 server_socket.h \
 		 handshake.h \
-		 entity_manager.h \
+		 network_game_manager.h \
 		 converter.h
 
Index: branches/network/src/lib/network/handshake.cc
===================================================================
--- branches/network/src/lib/network/handshake.cc	(revision 6115)
+++ branches/network/src/lib/network/handshake.cc	(revision 6116)
@@ -22,22 +22,12 @@
 #include "handshake.h"
 
-Handshake::Handshake( bool server, int clientId, int entityManagerId )
+Handshake::Handshake( bool server, int clientId, int networkGameManagerId )
 {
   /* set the class id for the base object */
   this->setClassID(CL_HANDSHAKE, "Handshake");
 
-  if ( clientId > 255 )
-  {
-    PRINTF(1)("clientId is too big for type byte (%d)! connection to client %d will not work!", clientId, clientId);
-  }
-
-  if ( entityManagerId > 255 )
-  {
-    PRINTF(1)("entityManagerId is too big for type byte (%d)! connection to client %d will not work!", entityManagerId, clientId);
-  }
-
   this->setIsServer(server);
   this->clientId = clientId;
-  this->entityManagerId = entityManagerId;
+  this->networkGameManagerId = networkGameManagerId;
   this->state = 0;
   this->isOk = false;
@@ -110,5 +100,5 @@
     this->isOk = true;
     this->newHostId = data[0];
-    this->newEntityManagerId = data[1];
+    this->newNetworkGameManagerId = data[1];
 
     if ( newHostId == 0 )
@@ -120,5 +110,5 @@
     else
     {
-      PRINTF(0)("got my hostID: %d\n", newHostId);
+      PRINTF(0)("got my hostID: %d and networkGameManagerId: %d\n", newHostId, newNetworkGameManagerId);
     }
     return;
@@ -189,5 +179,5 @@
       //memcpy(data, &clientId, 4);
       data[0] = (byte)clientId;
-      data[1] = (byte)entityManagerId;
+      data[1] = (byte)networkGameManagerId;
     }
     *reciever = clientId;
Index: branches/network/src/lib/network/handshake.h
===================================================================
--- branches/network/src/lib/network/handshake.h	(revision 6115)
+++ branches/network/src/lib/network/handshake.h	(revision 6116)
@@ -34,8 +34,9 @@
 {
   public:
-    Handshake(bool server, int clientId = 0, int entityManagerId = 0);
+    Handshake(bool server, int clientId = 0, int networkGameManagerId = 0);
     inline bool       completed(){ return hasState( HS_COMPLETED ); }
     inline bool       ok(){ return isOk; }
     inline int        getHostId(){ return newHostId; }
+    inline int        getNetworkGameManagerId(){ return newNetworkGameManagerId; }
 
     inline void       doReject(){ setState(HS_DO_REJECT); }
@@ -49,7 +50,7 @@
     int               state;
     int               clientId;
-    int               entityManagerId;
+    int               networkGameManagerId;
     int               newHostId;
-    int               newEntityManagerId;
+    int               newNetworkGameManagerId;
     bool              isOk;
 
Index: branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- branches/network/src/lib/network/network_game_manager.cc	(revision 6115)
+++ branches/network/src/lib/network/network_game_manager.cc	(revision 6116)
@@ -21,5 +21,5 @@
 
 /* include your own header */
-#include "entity_manager.h"
+#include "network_game_manager.h"
 
 
@@ -30,5 +30,5 @@
  * Standard constructor
  */
-EntityManager::EntityManager()
+NetworkGameManager::NetworkGameManager()
 {
   /* set the class id for the base object */
@@ -39,22 +39,22 @@
  * Standard destructor
  */
-EntityManager::~EntityManager()
+NetworkGameManager::~NetworkGameManager()
 {
 }
 
 
-void EntityManager::writeBytes(const byte* data, int length)
+void NetworkGameManager::writeBytes(const byte* data, int length)
 {
 }
 
-int EntityManager::readBytes(byte* data, int maxLength, int * reciever)
+int NetworkGameManager::readBytes(byte* data, int maxLength, int * reciever)
 {
 }
 
-void EntityManager::writeDebug() const
+void NetworkGameManager::writeDebug() const
 {
 }
 
-void EntityManager::readDebug() const
+void NetworkGameManager::readDebug() const
 {
 }
@@ -66,5 +66,5 @@
  * @param classID: The ID of the class of which an entity should be created
  */
-void EntityManager::createEntity(int classID)
+void NetworkGameManager::createEntity(int classID)
 {
 }
@@ -75,5 +75,5 @@
  * @param uniqueID: The ID of the entity object which should be removed
  */
-void EntityManager::removeEntity(int uniqueID)
+void NetworkGameManager::removeEntity(int uniqueID)
 {
 }
@@ -85,5 +85,5 @@
  * @param classID: The ID of the class of which an entity should be created
  */
-void EntityManager::requestCreateEntity(int classID)
+void NetworkGameManager::requestCreateEntity(int classID)
 {
 }
@@ -93,5 +93,5 @@
  * @param uniqueID: The ID of the entity object which should be removed
  */
-void EntityManager::requestRemoveEntity(int uniqueID)
+void NetworkGameManager::requestRemoveEntity(int uniqueID)
 {
 }
@@ -102,5 +102,5 @@
  * @param classID: The ID of the class of which an entity should be created
  */
-void EntityManager::executeCreateEntity(int classID)
+void NetworkGameManager::executeCreateEntity(int classID)
 {
 }
@@ -111,5 +111,5 @@
  * @param uniqueID: The ID of the entity object which should be removed
  */
-void EntityManager::executeRemoveEntity(int uniqueID)
+void NetworkGameManager::executeRemoveEntity(int uniqueID)
 {
 }
@@ -119,5 +119,5 @@
  * @return: true if the entity can be created, false otherwise
  */
-bool EntityManager::canCreateEntity(int classID)
+bool NetworkGameManager::canCreateEntity(int classID)
 {
 }
Index: branches/network/src/lib/network/network_game_manager.h
===================================================================
--- branches/network/src/lib/network/network_game_manager.h	(revision 6115)
+++ branches/network/src/lib/network/network_game_manager.h	(revision 6116)
@@ -4,6 +4,6 @@
  */
 
-#ifndef _ENTITY_MANGER
-#define _ENTITY_MANAGER
+#ifndef _NETWORK_GAME_MANGER
+#define _NETWORK_GAME_MANAGER
 
 /* include this file, it contains some default definitions */
@@ -45,9 +45,9 @@
  * a class that can create and remove entities
  */
-class EntityManager: public Synchronizeable
+class NetworkGameManager: public Synchronizeable
 {
   public:
-    EntityManager();
-    ~EntityManager();
+    NetworkGameManager();
+    ~NetworkGameManager();
 
     virtual void writeBytes(const byte* data, int length);
Index: branches/network/src/lib/sound/sound_engine.cc
===================================================================
--- branches/network/src/lib/sound/sound_engine.cc	(revision 6115)
+++ branches/network/src/lib/sound/sound_engine.cc	(revision 6116)
@@ -291,5 +291,5 @@
 
 
-  ALchar deviceName[] =
+  ALubyte deviceName[] =
 
 #ifdef __WIN32__