Index: branches/objectmanager/src/util/object_manager.cc
===================================================================
--- branches/objectmanager/src/util/object_manager.cc	(revision 6091)
+++ branches/objectmanager/src/util/object_manager.cc	(revision 6119)
@@ -150,129 +150,66 @@
 const char* ObjectManager::OMListToString(OM_LIST omList)
 {
-  switch (omList)
-  {
-    case OM_DEAD:
-      return "dead";
-    case OM_ENVIRON_NOTICK:
-      return "environ-notick";
-    case OM_ENVIRON:
-      return "environ";
-    case OM_COMMON:
-      return "common";
-    case OM_GROUP_00:
-      return "group00";
-    case OM_GROUP_00_PROJ:
-      return "group00-proj";
-    case OM_GROUP_01:
-      return "group01";
-    case OM_GROUP_01_PROJ:
-      return "group01-proj";
-    case OM_GROUP_02:
-      return "group02";
-    case OM_GROUP_02_PROJ:
-      return "group02-proj";
-    case OM_GROUP_03:
-      return "group03";
-    case OM_GROUP_03_PROJ:
-      return "group03-proj";
-    case OM_GROUP_04:
-      return "group04";
-    case OM_GROUP_04_PROJ:
-      return "group04-proj";
-    case OM_GROUP_05:
-      return "group05";
-    case OM_GROUP_05_PROJ:
-      return "group05-proj";
-    case OM_GROUP_06:
-      return "group06";
-    case OM_GROUP_06_PROJ:
-      return "group06-proj";
-    case OM_GROUP_07:
-      return "group07";
-    case OM_GROUP_07_PROJ:
-      return "group07-proj";
-    case OM_GROUP_08:
-      return "group08";
-    case OM_GROUP_08_PROJ:
-      return "group08-proj";
-    case OM_GROUP_09:
-      return "group09";
-    case OM_GROUP_09_PROJ:
-      return "group09-proj";
-    case OM_GROUP_10:
-      return "group10";
-    case OM_GROUP_10_PROJ:
-      return "group10-proj";
-    case OM_GROUP_11:
-      return "group11";
-    case OM_GROUP_11_PROJ:
-      return "group11-proj";
-    case OM_GROUP_12:
-      return "group11";
-    case OM_GROUP_12_PROJ:
-      return "group12-proj";
-    case OM_GROUP_13:
-      return "group03";
-    case OM_GROUP_13_PROJ:
-      return "group13-proj";
-    case OM_GROUP_14:
-      return "group14";
-    case OM_GROUP_14_PROJ:
-      return "group14-proj";
-    case OM_GROUP_15:
-      return "group15";
-    case OM_GROUP_15_PROJ:
-      return "group15-proj";
-    default:
-      return "null";
-  }
-
-}
-
-
-
+  return ObjectManager::objectManagerListNames[omList];
+}
+
+
+
+/**
+ * @brief transforms a String into an OM_LIST (usefull for debugging/Loading).
+ * @param listName the OM_LIST-name to be transformed into an OM_LIST.
+ * @returns the OM_LIST transformed from listName. or the default, if not found or NULL.
+ */
 OM_LIST ObjectManager::StringToOMList(const char* listName)
 {
   if (unlikely(listName == NULL)) return OM_DEFAULT_LIST;
 
-  if (!strcmp(listName, "dead")) return OM_DEAD;
-  if (!strcmp(listName, "environ-notick")) return OM_ENVIRON_NOTICK;
-  if (!strcmp(listName, "environ")) return OM_ENVIRON;
-  if (!strcmp(listName, "common")) return OM_COMMON;
-
-  if (!strcmp(listName, "group00")) return OM_GROUP_00;
-  if (!strcmp(listName, "group00-proj")) return OM_GROUP_00_PROJ;
-  if (!strcmp(listName, "group01")) return OM_GROUP_01;
-  if (!strcmp(listName, "group01-proj")) return OM_GROUP_01_PROJ;
-  if (!strcmp(listName, "group02")) return OM_GROUP_02;
-  if (!strcmp(listName, "group02-proj")) return OM_GROUP_02_PROJ;
-  if (!strcmp(listName, "group03")) return OM_GROUP_03;
-  if (!strcmp(listName, "group03-proj")) return OM_GROUP_03_PROJ;
-  if (!strcmp(listName, "group04")) return OM_GROUP_04;
-  if (!strcmp(listName, "group04-proj")) return OM_GROUP_04_PROJ;
-  if (!strcmp(listName, "group05")) return OM_GROUP_05;
-  if (!strcmp(listName, "group05-proj")) return OM_GROUP_05_PROJ;
-  if (!strcmp(listName, "group06")) return OM_GROUP_06;
-  if (!strcmp(listName, "group06-proj")) return OM_GROUP_06_PROJ;
-  if (!strcmp(listName, "group07")) return OM_GROUP_07;
-  if (!strcmp(listName, "group07-proj")) return OM_GROUP_07_PROJ;
-  if (!strcmp(listName, "group08")) return OM_GROUP_08;
-  if (!strcmp(listName, "group08-proj")) return OM_GROUP_08_PROJ;
-  if (!strcmp(listName, "group09")) return OM_GROUP_09;
-  if (!strcmp(listName, "group09-proj")) return OM_GROUP_09_PROJ;
-  if (!strcmp(listName, "group10")) return OM_GROUP_10;
-  if (!strcmp(listName, "group10-proj")) return OM_GROUP_10_PROJ;
-  if (!strcmp(listName, "group11")) return OM_GROUP_11;
-  if (!strcmp(listName, "group11-proj")) return OM_GROUP_11_PROJ;
-  if (!strcmp(listName, "group12")) return OM_GROUP_12;
-  if (!strcmp(listName, "group12-proj")) return OM_GROUP_12_PROJ;
-  if (!strcmp(listName, "group13")) return OM_GROUP_13;
-  if (!strcmp(listName, "group13-proj")) return OM_GROUP_13_PROJ;
-  if (!strcmp(listName, "group14")) return OM_GROUP_14;
-  if (!strcmp(listName, "group14-proj")) return OM_GROUP_14_PROJ;
-  if (!strcmp(listName, "group15")) return OM_GROUP_15;
-  if (!strcmp(listName, "group15-proj")) return OM_GROUP_15_PROJ;
-
+  for(unsigned int i = 0; i < OM_SIZE; ++i) {
+    if(!strcmp(listName, ObjectManager::objectManagerListNames[i])) {
+      return (OM_LIST)i;
+    }
+  }
   return OM_DEFAULT_LIST;
 }
 
+
+
+const char* ObjectManager::objectManagerListNames[] = {
+    "null",
+    "dead",
+    "environ-notick",
+    "environ",
+    "common",
+
+    "group00",
+    "group00-proj",
+    "group01",
+    "group01-proj",
+    "group02",
+    "group02-proj",
+    "group03",
+    "group03-proj",
+    "group04",
+    "group04-proj",
+    "group05",
+    "group05-proj",
+    "group06",
+    "group06-proj",
+    "group07",
+    "group07-proj",
+    "group08",
+    "group08-proj",
+    "group09",
+    "group09-proj",
+    "group10",
+    "group10-proj",
+    "group11",
+    "group11-proj",
+    "group12",
+    "group12-proj",
+    "group13",
+    "group13-proj",
+    "group14",
+    "group14-proj",
+    "group15",
+    "group15-proj"
+};