Index: /branches/objectmanager/src/lib/graphics/graphics_engine.cc
===================================================================
--- /branches/objectmanager/src/lib/graphics/graphics_engine.cc	(revision 6125)
+++ /branches/objectmanager/src/lib/graphics/graphics_engine.cc	(revision 6126)
@@ -19,4 +19,6 @@
 #include "resource_manager.h"
 #include "event_handler.h"
+
+#include "world_entity.h"
 
 #include "render_2d.h"
@@ -573,4 +575,13 @@
 }
 
+void GraphicsEngine::draw(const std::list<WorldEntity*>& drawList ) const
+{
+  std::list<WorldEntity*>::const_iterator entity;
+  for (entity = drawList.begin(); entity != drawList.end(); entity++)
+    if ((*entity)->isVisible()) 
+      (*entity)->draw(); 
+}
+
+
 /**
  * displays the Frames per second
Index: /branches/objectmanager/src/lib/graphics/graphics_engine.h
===================================================================
--- /branches/objectmanager/src/lib/graphics/graphics_engine.h	(revision 6125)
+++ /branches/objectmanager/src/lib/graphics/graphics_engine.h	(revision 6126)
@@ -15,8 +15,11 @@
 #include "glincl.h"
 
+#include <list>
+
 // Forward Declaration
 class Text;
 class IniParser;
 class SubString;
+class WorldEntity;
 
 //! class to handle graphics
@@ -66,4 +69,5 @@
     void tick(float dt);
     void draw() const;
+    void draw(const std::list<WorldEntity*>& drawList) const;
     void displayFPS(bool display);
 
Index: /branches/objectmanager/src/story_entities/world.cc
===================================================================
--- /branches/objectmanager/src/story_entities/world.cc	(revision 6125)
+++ /branches/objectmanager/src/story_entities/world.cc	(revision 6126)
@@ -721,4 +721,5 @@
       this->gameTime += this->dtS;
 
+
       tIterator<WorldEntity>* iterator = this->entities->getIterator();
       WorldEntity* entity = iterator->firstElement();
@@ -805,4 +806,13 @@
 void World::draw ()
 {
+  GraphicsEngine* engine = GraphicsEngine::getInstance();
+  engine->draw(State::getObjectManager()->getObjectList(OM_ENVIRON_NOTICK));
+  engine->draw(State::getObjectManager()->getObjectList(OM_ENVIRON));
+  engine->draw(State::getObjectManager()->getObjectList(OM_COMMON));
+  engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_00));
+  engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_01));
+  engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_01_PROJ));
+  
+  
   /* draw entities */
   WorldEntity* entity;
@@ -825,5 +835,5 @@
     PNode::getNullParent()->debugDraw(0);
 
-  GraphicsEngine::getInstance()->draw();
+  engine->draw();
   //TextEngine::getInstance()->draw();
 }
Index: /branches/objectmanager/src/util/object_manager.cc
===================================================================
--- /branches/objectmanager/src/util/object_manager.cc	(revision 6125)
+++ /branches/objectmanager/src/util/object_manager.cc	(revision 6126)
@@ -133,5 +133,5 @@
   if (omList != OM_INIT || omList == OM_SIZE)
   {
-    PRINT(0)(" +ObjectManager-LIST: '%s'-size='%d'-----\n", ObjectManager::OMListToString((OM_LIST)omList), this->objectLists[omList].size());
+    PRINT(0)(" +ObjectManager-LIST: '%s'==size='%d'==---\n", ObjectManager::OMListToString((OM_LIST)omList), this->objectLists[omList].size());
   //  if (level >= 1)
     {
@@ -144,5 +144,5 @@
   }
   else
-    PRINTF(2)("Invalid query. for OM_INIT-LIST\n");
+    PRINTF(2)("Invalid query. for OM_INIT-LIST or OM_SIZE\n");
 }
 
Index: /branches/objectmanager/src/world_entities/weapons/guided_missile.cc
===================================================================
--- /branches/objectmanager/src/world_entities/weapons/guided_missile.cc	(revision 6125)
+++ /branches/objectmanager/src/world_entities/weapons/guided_missile.cc	(revision 6126)
@@ -153,5 +153,4 @@
   if (this->target != NULL && this->target->getParent() != PNode::getNullParent())
    {
-     printf("========%s::%s\n", target->getParent()->getClassName(), target->getParent()->getName() );
      velocity += ((target->getAbsCoor() - this->getAbsCoor()).getNormalized())*agility;
      float speed = velocity.len();